﻿using System;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace infragistics_memory_test
{
    public partial class UltraTreeForm : Form
    {
        private readonly TreeNodeFormatter _treeNodeFormatter = new TreeNodeFormatter();

        public UltraTreeForm()
        {
            InitializeComponent();
        }

        private void buttonAddNodes_Click(object sender, EventArgs e)
        {
            ultraTree1.BeginUpdate();
            var rdxNodeColumnsDefinition = _treeNodeFormatter.Format(ultraTree1);
            var treeNodeBuilder = new TreeNodeBuilder();
            treeNodeBuilder.BuildTreeNode(ultraTree1, rdxNodeColumnsDefinition);
            ultraTree1.EndUpdate();
        }       

        private void buttonClear_Click(object sender, EventArgs e)
        {
            // MRS
            // Clear the Appearances collection so that the Appearances in it don't root any nodes or
            // cells. 
            ultraTree1.Appearances.Clear();

            ultraTree1.Nodes.Clear();

            // MRS
            // Added garbage collection here for accurate memory profiler results. This is
            // not really needed in the application. 
            GC.Collect();
            GC.WaitForPendingFinalizers();
            GC.Collect();
        }

        private void buttonExpand_Click(object sender, EventArgs e)
        {
            ultraTree1.ExpandAll();
        }
    }
}
